Package org.codehaus.groovy.transform

# Class IndexedPropertyASTStubber

java.lang.Object
org.codehaus.groovy.transform.AbstractASTTransformation
org.codehaus.groovy.transform.IndexedPropertyASTStubber

All Implemented Interfaces:
  `ASTTransformation`, `ErrorCollecting`

public class IndexedPropertyASTStubber extends AbstractASTTransformation
Joint-compilation stubber for `IndexedProperty`. Emits placeholder indexed accessors `getXxx(int)` and (for non-immutable fields) `setXxx(int, T)` so Java consumers can call them against the joint-compilation stub.

Component type detection mirrors the full transform:

- Array fields: component type is `T` from `T[]`.
- List fields: component type is the first generic parameter, or `Object` if the list is raw.
- Other field types: skipped (the full transform reports an error).

Setter emission is suppressed when the enclosing class carries an Immutable-family annotation (`@Immutable`, `groovy.transform.ImmutableBase`, or `groovy.transform.KnownImmutable`). The full transform's runtime guard uses field-level `IMMUTABLE_BREADCRUMB` metadata which isn't set until CANONICALIZATION; the class-level annotation check is a CONVERSION-time approximation that matches the typical usage pattern. Less common configurations may produce a stub that over-claims the setter — flagged in the GEP-21 spike notes.

Since:
  6.0.0

- ## Field Summary

  ### Fields inherited from class org.codehaus.groovy.transform.AbstractASTTransformation

  `RETENTION_CLASSNODE, sourceUnit`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `IndexedPropertyASTStubber()`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `visit(ASTNode[] nodes, SourceUnit source)`
  The method is invoked when an AST Transformation is active.

  ### Methods inherited from class org.codehaus.groovy.transform.AbstractASTTransformation

  `addError, checkIncludeExcludeUndefinedAware, checkIncludeExcludeUndefinedAware, checkNotInterface, checkPropertyList, checkPropertyList, checkPropertyList, copyAnnotatedNodeAnnotations, copyAnnotatedNodeAnnotations, deemedInternal, deemedInternalName, getAnnotationName, getMemberClassList, getMemberClassValue, getMemberClassValue, getMemberIntValue, getMemberStringList, getMemberStringValue, getMemberStringValue, getMemberValue, hasAnnotation, init, markAsInternal, memberHasValue, shouldSkip, shouldSkip, shouldSkip, shouldSkipOnDescriptorUndefinedAware, shouldSkipUndefinedAware, shouldSkipUndefinedAware, shouldSkipUndefinedAware, tokenize`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Constructor Details

  - ### IndexedPropertyASTStubber

    public IndexedPropertyASTStubber()

- ## Method Details

  - ### visit

    public void visit(ASTNode[] nodes, SourceUnit source)
    Description copied from interface: `ASTTransformation`
    The method is invoked when an AST Transformation is active. For local transformations, it is invoked once each time the local annotation is encountered. For global transformations, it is invoked once for every source unit, which is typically a source file.
    Parameters:
      `nodes` - The ASTnodes when the call was triggered. Element 0 is the AnnotationNode that triggered this annotation to be activated. Element 1 is the AnnotatedNode decorated, such as a MethodNode or ClassNode. For global transformations it is usually safe to ignore this parameter.
      `source` - The source unit being compiled. The source unit may contain several classes. For global transformations, information about the AST can be retrieved from this object.